// Document.h : Declaration of the CDocument

#ifndef __DOCUMENT_H_
#define __DOCUMENT_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CDocument

class CApplication;
class CDocumentCollection;

class ATL_NO_VTABLE CDocument : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CDocument, &CLSID_Document>,
	public IDispatchImpl<IDocument, &IID_IDocument>,
    public ICycleDetectImpl<CDocument>
{
public:
    HRESULT FinalConstruct();
    void    FinalRelease();

    HRESULT Init(IDocumentCollection* pParent);
    void    Close();

DECLARE_REGISTRY_RESOURCEID(IDR_DOCUMENT)
DECLARE_NOT_AGGREGATABLE(CDocument)
DECLARE_CYCLE_DETECT(CDocument)
//DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CDocument)
	COM_INTERFACE_ENTRY(IDocument)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ICycleDetect)
    COM_INTERFACE_ENTRY_THIS()
END_COM_MAP()

// IDocument
public:
	STDMETHOD(get_Parent)(/*[out, retval]*/ IDocumentCollection** ppVal);
	STDMETHOD(get_Application)(/*[out, retval]*/ IApplication** ppVal);
	STDMETHOD(get_Data)(/*[out, retval]*/ BSTR* pVal);
	STDMETHOD(put_Data)(/*[in]*/ BSTR newVal);

private:
    CComBSTR    m_bstrData;
    CComCyclePtr<IDocumentCollection>   m_spParent;
    CComCyclePtr<IApplication>          m_spApplication;
};

#endif //__DOCUMENT_H_
